Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/SlaveFacade.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/SlaveFacade.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/SlaveFacade.cs	(revision 4368)
@@ -37,4 +37,5 @@
 using HeuristicLab.Hive.Contracts.ResponseObjects;
 using System.Security.Permissions;
+using HeuristicLab.Hive.JobBase;
 
 namespace HeuristicLab.Hive.Server.Core {
@@ -42,4 +43,5 @@
   public class SlaveFacade : ISlaveFacade {
     private ISlaveCommunicator slaveCommunicator = ServiceLocator.GetSlaveCommunicator();
+    private IJobManager jobManager = ServiceLocator.GetJobManager();
     private IContextFactory contextFactory = ServiceLocator.GetContextFactory();
 
@@ -126,4 +128,13 @@
       using (contextFactory.GetContext()) {
         return slaveCommunicator.SetCalendarStatus(slaveId, state);
+      }
+    }
+
+    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Administrator)]
+    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Slave)]
+    public ResponseObject<JobDto> AddChildJob(Guid parentJobId, SerializedJob serializedJob) {
+      using (contextFactory.GetContext()) {
+        return jobManager.AddChildJob(parentJobId, serializedJob);
+        
       }
     }
@@ -186,4 +197,28 @@
       }
     }
+
+    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Administrator)]
+    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Slave)]
+    public ResponseObject<JobDto> PauseJob(SerializedJob serializedJob) {
+      using (contextFactory.GetContext()) {
+        return jobManager.PauseJob(serializedJob);
+      }
+    }
+
+    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Administrator)]
+    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Slave)]
+    public JobResultList GetChildJobResults(Guid? parentJobId, bool recursive, bool includeParent) {
+      using (contextFactory.GetContext(false)) {
+        return jobManager.GetChildJobResults(parentJobId, recursive, includeParent).Obj;
+      }
+    }
+
+    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Administrator)]
+    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Slave)]
+    public SerializedJob GetLastSerializedResult(Guid jobId) {
+      using (contextFactory.GetContext(false)) {
+        return jobManager.GetLastSerializedResult(jobId).Obj;
+      }
+    }
     #endregion
   }
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/HeuristicLab.Hive.Server.Core-3.3.csproj
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/HeuristicLab.Hive.Server.Core-3.3.csproj	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/HeuristicLab.Hive.Server.Core-3.3.csproj	(revision 4368)
@@ -83,4 +83,7 @@
       <HintPath>C:\Program Files\HeuristicLab 3.3\HeuristicLab.Common-3.3.dll</HintPath>
     </Reference>
+    <Reference Include="HeuristicLab.Core-3.3">
+      <HintPath>..\..\..\..\..\..\..\..\Program Files\HeuristicLab 3.3\HeuristicLab.Core-3.3.dll</HintPath>
+    </Reference>
     <Reference Include="HeuristicLab.PluginInfrastructure-3.3">
       <HintPath>C:\Program Files\HeuristicLab 3.3\HeuristicLab.PluginInfrastructure-3.3.dll</HintPath>
@@ -150,4 +153,8 @@
       <Name>HeuristicLab.Hive.Contracts-3.3</Name>
     </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Hive.JobBase\3.3\HeuristicLab.Hive.JobBase-3.3.csproj">
+      <Project>{21187322-52DD-4243-80A4-A85F0263E63B}</Project>
+      <Name>HeuristicLab.Hive.JobBase-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Hive.Server.DataAccess\3.3\HeuristicLab.Hive.Server.DataAccess-3.3.csproj">
       <Project>{4D5A2A16-66C2-431D-9AA3-BD3041E64B84}</Project>
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/InternalInterfaces/IAuthorizationManager.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/InternalInterfaces/IAuthorizationManager.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/InternalInterfaces/IAuthorizationManager.cs	(revision 4368)
@@ -4,5 +4,5 @@
   public interface IAuthorizationManager {
 
-    string UserId { get; }
+    Guid UserId { get; }
 
     /// <summary>
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/JobManager.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/JobManager.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/JobManager.cs	(revision 4368)
@@ -39,4 +39,5 @@
 using IsolationLevel = System.Transactions.IsolationLevel;
 using HeuristicLab.Hive.Contracts.ResponseObjects;
+using HeuristicLab.Hive.JobBase;
 
 namespace HeuristicLab.Hive.Server.Core {
@@ -141,5 +142,5 @@
         }
       }
-      return AddNewJob(job);
+      return AddNewJob(job, true);
     }
 
@@ -148,6 +149,7 @@
     /// </summary>
     /// <param name="job"></param>
-    /// <returns></returns>
-    public ResponseObject<JobDto> AddNewJob(SerializedJob job) {
+    /// <param name="overrideUserid">if false, job.JobInfo.UserId will not be overridden</param>
+    /// <returns></returns>
+    public ResponseObject<JobDto> AddNewJob(SerializedJob job, bool overrideUserid) {
       ResponseObject<JobDto> response = new ResponseObject<JobDto>();
 
@@ -167,5 +169,7 @@
 
         job.JobInfo.DateCreated = DateTime.Now;
-        job.JobInfo.UserId = ServiceLocator.GetAuthorizationManager().UserId;
+        if (overrideUserid) {
+          job.JobInfo.UserId = ServiceLocator.GetAuthorizationManager().UserId;
+        }
         DaoLocator.JobDao.InsertWithAttachedJob(job);
         DaoLocator.PluginInfoDao.InsertPluginDependenciesForJob(job.JobInfo);
@@ -177,4 +181,8 @@
 
       return response;
+    }
+
+    public ResponseObject<JobDto> AddNewJob(SerializedJob job) {
+      return AddNewJob(job, true);
     }
 
@@ -213,31 +221,29 @@
     //}
 
-    // [chn] [refactor] why does this method handle 3 different cases? wouldn't 3 methods be easier?
-    //Requested means: there MUST be a job result which gets sent back
-    // requested==true: resultat mit job
-    // requested==false: 
-    public ResponseObject<SerializedJob> GetLastSerializedResult(Guid jobId, bool requested, bool snapshot) {
+    public ResponseObject<SerializedJob> GetLastSerializedResult(Guid jobId) {
       ResponseObject<SerializedJob> response = new ResponseObject<SerializedJob>();
-
       JobDto job = DaoLocator.JobDao.FindById(jobId);
 
-      //if it's a snapshot but the result hasn't reached the server yet...
-      if (snapshot && (job.State == JobState.SnapshotRequested || job.State == JobState.SnapshotSent)) {
-        response.StatusMessage = ResponseStatus.GetLastSerializedResult_JobResultNotYetThere;
-
-        return response;
-      }
-
-      //if it's NOT a snapshot, NEITHER request NOR is it finished
-      if (!requested && !snapshot && job.State != JobState.Finished) {
-        response.StatusMessage = ResponseStatus.GetLastSerializedResult_JobResultNotYetThere;
-
-        return response;
-      }
-
-      //every other case - snapshot, job finished or it's requested
       response.Obj = new SerializedJob();
       response.Obj.JobInfo = job;
 
+      response.Obj.SerializedJobData = DaoLocator.JobDao.GetBinaryJobFile(jobId);
+
+      return response;
+    }
+
+    public ResponseObject<SerializedJob> GetSnapshotResult(Guid jobId) {
+      ResponseObject<SerializedJob> response = new ResponseObject<SerializedJob>();
+
+      JobDto job = DaoLocator.JobDao.FindById(jobId);
+
+      //if it's a snapshot but the result hasn't reached the server yet...
+      if (job.State == JobState.SnapshotRequested || job.State == JobState.SnapshotSent) {
+        response.StatusMessage = ResponseStatus.GetSnapshotResult_JobResultNotYetThere;
+        return response;
+      }
+
+      response.Obj = new SerializedJob();
+      response.Obj.JobInfo = job;
       response.Obj.SerializedJobData = DaoLocator.JobDao.GetBinaryJobFile(jobId);
 
@@ -304,5 +310,5 @@
       foreach (JobDto job in jobs) {
         jobResultList.Add(new JobResult() {
-          JobId = job.Id,
+          Id = job.Id,
           State = job.State,
           DateCalculated = job.DateCalculated,
@@ -324,4 +330,64 @@
     }
 
+    public ResponseObject<JobResultList> GetChildJobResults(Guid? parentJobId, bool recursive, bool includeParent) {
+      ResponseObject<JobResultList> response = new ResponseObject<JobResultList>();
+      JobResultList jobResultList = new JobResultList();
+
+      IList<JobDto> jobs = DaoLocator.JobDao.FindJobsByParentId(parentJobId, recursive).ToList();
+      if (!parentJobId.HasValue) {
+        jobs = jobs.Where(job => job.UserId == ServiceLocator.GetAuthorizationManager().UserId).ToList();
+      }
+
+      if (includeParent && parentJobId.HasValue) {
+        jobs.Add(DaoLocator.JobDao.FindById(parentJobId.Value));
+      }
+
+      foreach (JobDto job in jobs) {
+        if (job != null) {
+          jobResultList.Add(new JobResult() {
+            Id = job.Id,
+            State = job.State,
+            DateCreated = job.DateCreated,
+            DateCalculated = job.DateCalculated,
+            DateFinished = job.DateFinished,
+            Exception = job.Exception,
+            Percentage = job.Percentage,
+            ParentJobId = job.ParentJob != null ? new Nullable<Guid>(job.ParentJob.Id) : null
+          });
+        }
+      }
+      
+      response.Obj = jobResultList;
+      return response;
+    }
+
+    public ResponseObject<JobDto> AddChildJob(Guid parentJobId, SerializedJob serializedJob) {
+      JobDto parentJob = DaoLocator.JobDao.FindById(parentJobId);
+
+      serializedJob.JobInfo.ParentJob = parentJob;
+      serializedJob.JobInfo.UserId = parentJob.UserId;
+      serializedJob.JobInfo.AssignedResourceIds = parentJob.AssignedResourceIds;
+
+      return AddNewJob(serializedJob, false);
+    }
+
+    public ResponseObject<JobDto> PauseJob(SerializedJob serializedJob) {
+      JobDto jobDto = DaoLocator.JobDao.FindById(serializedJob.JobInfo.Id);
+
+      jobDto.State = serializedJob.JobInfo.State;
+      jobDto.Percentage = serializedJob.JobInfo.Percentage;
+      
+
+      DaoLocator.JobDao.SetBinaryJobFile(serializedJob.JobInfo.Id, serializedJob.SerializedJobData);
+      DaoLocator.JobDao.Update(jobDto);
+
+      DaoLocator.JobDao.UnAssignSlaveToJob(jobDto.Id);
+
+      return new ResponseObject<JobDto>() {
+        Obj = jobDto,
+        StatusMessage = ResponseStatus.Ok
+      };
+    }
+
     #endregion
 
@@ -352,4 +418,8 @@
     }
     #endregion
+
+
+    
+
   }
 }
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/SlaveCommunicator.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/SlaveCommunicator.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/SlaveCommunicator.cs	(revision 4368)
@@ -39,4 +39,5 @@
 using System.ServiceModel;
 using System.Security;
+using HeuristicLab.Hive.JobBase;
 
 namespace HeuristicLab.Hive.Server.Core {
@@ -465,5 +466,5 @@
       //tx = session.BeginTransaction();
 
-      ResponseResultReceived response = ProcessJobResult(result.SlaveId, result.JobId, new byte[] { }, result.Percentage, result.Exception, finished);
+      ResponseResultReceived response = ProcessJobResult(result.SlaveId, result.Id, new byte[] { }, result.Percentage, result.Exception, finished);
 
       if (response.StatusMessage == ResponseStatus.Ok) {
@@ -487,5 +488,5 @@
         //jobStream.Close();
 
-        DaoLocator.JobDao.SetBinaryJobFile(result.JobId, serializedJob.ToArray());
+        DaoLocator.JobDao.SetBinaryJobFile(result.Id, serializedJob.ToArray());
       }
       Logger.Info("END Job received for Storage:");
@@ -721,5 +722,5 @@
       return currCachedPlugin;
     }
-
+    
     #endregion
   }
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.DataAccess/3.3/IJobDao.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.DataAccess/3.3/IJobDao.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.DataAccess/3.3/IJobDao.cs	(revision 4368)
@@ -13,4 +13,6 @@
     void AssignSlaveToJob(Guid slaveId, Guid jobId);
 
+    void UnAssignSlaveToJob(Guid jobId);
+
     void SetJobOffline(JobDto job);
 
@@ -19,5 +21,5 @@
     byte[] GetBinaryJobFile(Guid jobId); 
 
-    IEnumerable<JobDto> FindFittingJobsForSlave(JobState state, int freeCores, int freeMemory, Guid slaveGuid);
+    IEnumerable<JobDto> FindFittingJobs(JobState state, int freeCores, int freeMemory, Guid slaveGuid);
 
     Stream GetSerializedJobStream(Guid jobId);
@@ -29,5 +31,12 @@
     IEnumerable<JobDto> FindJobsById(IEnumerable<Guid> jobIds);
 
-    bool IsUserAuthorizedForJobs(string userId, params Guid[] jobIds);
+    bool IsUserAuthorizedForJobs(Guid userId, params Guid[] jobIds);
+
+    IEnumerable<JobDto> FindJobsByParentId(Guid? parentJobId, bool recursive);
+
+    /// <summary>
+    /// Returns a list of jobs which are on state WaitForChildJobs and those child-jobs are finished
+    /// </summary>
+    IEnumerable<JobDto> FindJobsWithFinishedChilds(Guid guid);
   }
 }
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.LINQDataAccess/3.3/HiveDataContext.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.LINQDataAccess/3.3/HiveDataContext.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.LINQDataAccess/3.3/HiveDataContext.cs	(revision 4368)
@@ -1979,5 +1979,5 @@
 		private System.Nullable<System.Guid> _ProjectId;
 		
-		private string _UserId;
+		private System.Nullable<System.Guid> _UserId;
 		
 		private int _CoresNeeded;
@@ -2025,5 +2025,5 @@
     partial void OnProjectIdChanging(System.Nullable<System.Guid> value);
     partial void OnProjectIdChanged();
-    partial void OnUserIdChanging(string value);
+    partial void OnUserIdChanging(System.Nullable<System.Guid> value);
     partial void OnUserIdChanged();
     partial void OnCoresNeededChanging(int value);
@@ -2296,6 +2296,6 @@
 		}
 		
-		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_UserId", DbType="VarChar(MAX)")]
-		public string UserId
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_UserId", DbType="UniqueIdentifier")]
+		public System.Nullable<System.Guid> UserId
 		{
 			get
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.LINQDataAccess/3.3/JobDao.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.LINQDataAccess/3.3/JobDao.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.LINQDataAccess/3.3/JobDao.cs	(revision 4368)
@@ -73,6 +73,6 @@
       Job j = DtoToEntity(job.JobInfo, null);
       j.SerializedJob = job.SerializedJobData;
-      foreach (Guid assignRessourceId in job.JobInfo.AssignedResourceIds)
-        j.AssignedResources.Add(new AssignedResource { ResourceId = assignRessourceId });
+      //foreach (Guid assignRessourceId in job.JobInfo.AssignedResourceIds)
+      //  j.AssignedResources.Add(new AssignedResource { ResourceId = assignRessourceId });
       Context.Jobs.InsertOnSubmit(j);
       CommitChanges();
@@ -98,10 +98,11 @@
                      j.JobState == Enum.GetName(typeof(JobState), JobState.Aborted) ||
                      j.JobState == Enum.GetName(typeof(JobState), JobState.SnapshotRequested) ||
-                     j.JobState == Enum.GetName(typeof(JobState), JobState.SnapshotSent)) &&
+                     j.JobState == Enum.GetName(typeof(JobState), JobState.SnapshotSent) ||
+                     j.JobState == Enum.GetName(typeof(JobState), JobState.WaitForChildJobs)) &&
                     (j.ResourceId.Equals(slave.Id))
               select EntityToDto(j, null)).ToList();
     }
 
-    public IEnumerable<JobDto> FindFittingJobsForSlave(JobState state, int freeCores, int freeMemory, Guid slaveId) {
+    public IEnumerable<JobDto> FindFittingJobs(JobState state, int freeCores, int freeMemory, Guid slaveId) {
       SlaveGroupDao cgd = new SlaveGroupDao();
 
@@ -111,5 +112,5 @@
 
       var q = (from ar in Context.AssignedResources
-               where ar.Job.JobState == Enum.GetName(typeof(JobState), JobState.Offline) &&
+               where ar.Job.JobState == Enum.GetName(typeof(JobState), state) &&
                      ar.Job.CoresNeeded <= freeCores &&
                      ar.Job.MemoryNeeded <= freeMemory &&
@@ -120,4 +121,22 @@
     }
 
+    public IEnumerable<JobDto> FindJobsWithFinishedChilds(Guid slaveId) {
+      SlaveGroupDao cgd = new SlaveGroupDao();
+      
+      List<Guid> idList = new List<Guid>(cgd.FindAllGroupAndParentGroupIdsForSlave(slaveId));
+      //Add myself too - enables jobs for one specific host!
+      idList.Add(slaveId);
+
+      var query = from ar in Context.AssignedResources
+                  where ar.Job.JobState == Enum.GetName(typeof(JobState), JobState.WaitForChildJobs) &&
+                    (from child in Context.Jobs
+                     where child.ParentJobId == ar.Job.JobId
+                     select child.JobState == Enum.GetName(typeof(JobState), JobState.Finished)).All(x => x)
+                  orderby ar.Job.Priority descending
+                  select EntityToDto(ar.Job, null);
+      var list = query.ToList();
+      return list;
+    }
+
     public IEnumerable<JobDto> GetJobsByState(JobState state) {
       return (from j in Context.Jobs
@@ -127,8 +146,14 @@
 
     public void AssignSlaveToJob(Guid slaveId, Guid jobId) {
-      Slave c = Context.Resources.OfType<Slave>().SingleOrDefault(slave => slave.ResourceId.Equals(slaveId));
+      Slave s = Context.Resources.OfType<Slave>().SingleOrDefault(slave => slave.ResourceId.Equals(slaveId));
       Job j = Context.Jobs.SingleOrDefault(job => job.JobId.Equals(jobId));
-      c.Jobs.Add(j);
-      j.Slave = c;
+      s.Jobs.Add(j);
+      j.Slave = s;
+      CommitChanges();
+    }
+
+    public void UnAssignSlaveToJob(Guid jobId) {
+      Job j = Context.Jobs.SingleOrDefault(job => job.JobId.Equals(jobId));
+      j.Slave = null;
       CommitChanges();
     }
@@ -153,5 +178,5 @@
     }
 
-    public bool IsUserAuthorizedForJobs(string userId, params Guid[] jobIds) {
+    public bool IsUserAuthorizedForJobs(Guid userId, params Guid[] jobIds) {
       var jobs = from job in Context.Jobs
                  where jobIds.Contains(job.JobId)
@@ -159,4 +184,20 @@
       return jobs.All(job => job.UserId == userId);
     }
+
+    public IEnumerable<JobDto> FindJobsByParentId(Guid? parentJobId, bool recursive) {
+      IQueryable<JobDto> query = from job in Context.Jobs
+                                 where parentJobId == null ? !job.ParentJobId.HasValue : job.ParentJobId.Value == parentJobId
+                                 select EntityToDto(job, null);
+      List<JobDto> jobs = query.ToList();
+      if (recursive) {
+        List<JobDto> childs = new List<JobDto>();
+        foreach (JobDto job in jobs) {
+          childs.AddRange(FindJobsByParentId(job.Id, recursive));
+        }
+        jobs.AddRange(childs);
+      }
+      return jobs;
+    }
+
     #endregion
 
@@ -181,8 +222,17 @@
       target.JobState = Enum.GetName(typeof(JobState), source.State);
       target.UserId = source.UserId;
+      if (source.ParentJob != null) {
+        target.ParentJobId = source.ParentJob.Id;
+      }
+
+      foreach (Guid assignRessourceId in source.AssignedResourceIds) {
+        if (!target.AssignedResources.Select(x => x.ResourceId).Contains(assignRessourceId)) {
+          target.AssignedResources.Add(new AssignedResource { ResourceId = assignRessourceId });
+        }
+      }
+
       return target;
     }
 
-    //Assigned ressources are not used atm!
     //Slave is not used ATM - not sure when we stopped using those...
     public override JobDto EntityToDto(Job source, JobDto target) {
@@ -199,5 +249,5 @@
       target.DateFinished = source.DateFinished;
       target.Id = source.JobId;
-      
+
       target.Exception = source.Exception;
       target.Percentage = source.Percentage;
@@ -206,4 +256,10 @@
       target.State = (JobState)Enum.Parse(typeof(JobState), source.JobState, true);
       target.UserId = source.UserId;
+
+      if (source.ParentJobId.HasValue) {
+        target.ParentJob = new JobDto() { Id = source.ParentJobId.Value };
+      }
+      target.AssignedResourceIds = source.AssignedResources.Select(x => x.ResourceId).ToList();
+
       return target;
     }
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/GetJobCompletedEventArgs.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/GetJobCompletedEventArgs.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/GetJobCompletedEventArgs.cs	(revision 4368)
@@ -21,5 +21,5 @@
 using System;
 
-namespace HeuristicLab.Hive.Slave.Communication.SlaveService {
+namespace HeuristicLab.Hive.Slave.Communication.SlaveFacade {
   public partial class GetJobCompletedEventArgs : System.ComponentModel.AsyncCompletedEventArgs {
 
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/HeuristicLab.Hive.Slave.Communication-3.3.csproj
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/HeuristicLab.Hive.Slave.Communication-3.3.csproj	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/HeuristicLab.Hive.Slave.Communication-3.3.csproj	(revision 4368)
@@ -76,4 +76,5 @@
   </PropertyGroup>
   <ItemGroup>
+    <Reference Include="HeuristicLab.Collections-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
     <Reference Include="HeuristicLab.Common-3.3">
       <HintPath>C:\Program Files\HeuristicLab 3.3\HeuristicLab.Common-3.3.dll</HintPath>
@@ -112,9 +113,4 @@
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="GetJobCompletedEventArgs.cs" />
-    <Compile Include="Service References\SlaveService\Reference.cs">
-      <AutoGen>True</AutoGen>
-      <DesignTime>True</DesignTime>
-      <DependentUpon>Reference.svcmap</DependentUpon>
-    </Compile>
     <Compile Include="Properties\Settings.Designer.cs">
       <AutoGen>True</AutoGen>
@@ -122,5 +118,10 @@
       <DependentUpon>Settings.settings</DependentUpon>
     </Compile>
-    <Compile Include="SlaveServiceCache.cs" />
+    <Compile Include="Service References\SlaveFacade\Reference.cs">
+      <AutoGen>True</AutoGen>
+      <DesignTime>True</DesignTime>
+      <DependentUpon>Reference.svcmap</DependentUpon>
+    </Compile>
+    <Compile Include="ServiceLocator.cs" />
     <Compile Include="WcfService.cs" />
   </ItemGroup>
@@ -130,4 +131,6 @@
     <None Include="Properties\AssemblyInfo.frame" />
     <None Include="Properties\DataSources\HeuristicLab.Hive.Contracts.BusinessObjects.JobDto.datasource" />
+    <None Include="Properties\DataSources\HeuristicLab.Hive.Contracts.BusinessObjects.JobResult.datasource" />
+    <None Include="Properties\DataSources\HeuristicLab.Hive.Contracts.BusinessObjects.SerializedJob.datasource" />
     <None Include="Properties\DataSources\HeuristicLab.Hive.Contracts.ResponseObjects.Response.datasource" />
     <None Include="Properties\DataSources\HeuristicLab.Hive.Contracts.ResponseObjects.ResponseCalendar.datasource" />
@@ -135,40 +138,39 @@
     <None Include="Properties\DataSources\HeuristicLab.Hive.Contracts.ResponseObjects.ResponseResultReceived.datasource" />
     <None Include="Properties\DataSources\HeuristicLab.PluginInfrastructure.CachedHivePluginInfoDto.datasource" />
-    <None Include="Service References\SlaveService\SlaveFacade.wsdl" />
-    <None Include="Service References\SlaveService\SlaveService.wsdl" />
-    <None Include="Service References\SlaveService\SlaveService.xsd">
-      <SubType>Designer</SubType>
-    </None>
-    <None Include="Service References\SlaveService\SlaveService1.xsd">
-      <SubType>Designer</SubType>
-    </None>
-    <None Include="Service References\SlaveService\SlaveService2.xsd">
-      <SubType>Designer</SubType>
-    </None>
-    <None Include="Service References\SlaveService\SlaveService3.xsd">
-      <SubType>Designer</SubType>
-    </None>
-    <None Include="Service References\SlaveService\SlaveService4.xsd">
-      <SubType>Designer</SubType>
-    </None>
-    <None Include="Service References\SlaveService\SlaveService5.xsd">
-      <SubType>Designer</SubType>
-    </None>
-    <None Include="Service References\SlaveService\SlaveService6.xsd">
-      <SubType>Designer</SubType>
-    </None>
-    <None Include="Service References\SlaveService\SlaveService7.xsd">
-      <SubType>Designer</SubType>
-    </None>
-    <None Include="Service References\SlaveService\SlaveService8.xsd">
-      <SubType>Designer</SubType>
-    </None>
-    <None Include="Service References\SlaveService\SlaveService9.xsd">
-      <SubType>Designer</SubType>
-    </None>
     <None Include="Properties\Settings.settings">
       <Generator>SettingsSingleFileGenerator</Generator>
       <LastGenOutput>Settings.Designer.cs</LastGenOutput>
     </None>
+    <None Include="Service References\SlaveFacade\Arrays.xsd">
+      <SubType>Designer</SubType>
+    </None>
+    <None Include="Service References\SlaveFacade\HeuristicLab.DataAccess.xsd">
+      <SubType>Designer</SubType>
+    </None>
+    <None Include="Service References\SlaveFacade\HeuristicLab.Hive.Contracts.BusinessObjects.xsd">
+      <SubType>Designer</SubType>
+    </None>
+    <None Include="Service References\SlaveFacade\HeuristicLab.Hive.Contracts.ResponseObjects.xsd">
+      <SubType>Designer</SubType>
+    </None>
+    <None Include="Service References\SlaveFacade\HeuristicLab.Hive.Contracts.xsd">
+      <SubType>Designer</SubType>
+    </None>
+    <None Include="Service References\SlaveFacade\HeuristicLab.PluginInfrastructure.xsd">
+      <SubType>Designer</SubType>
+    </None>
+    <None Include="Service References\SlaveFacade\Message.xsd">
+      <SubType>Designer</SubType>
+    </None>
+    <None Include="Service References\SlaveFacade\service.wsdl" />
+    <None Include="Service References\SlaveFacade\service.xsd">
+      <SubType>Designer</SubType>
+    </None>
+    <None Include="Service References\SlaveFacade\service1.xsd">
+      <SubType>Designer</SubType>
+    </None>
+    <None Include="Service References\SlaveFacade\System.xsd">
+      <SubType>Designer</SubType>
+    </None>
   </ItemGroup>
   <ItemGroup>
@@ -176,4 +178,8 @@
       <Project>{134F93D7-E7C8-4ECD-9923-7F63259A60D8}</Project>
       <Name>HeuristicLab.Hive.Contracts-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Hive.JobBase\3.3\HeuristicLab.Hive.JobBase-3.3.csproj">
+      <Project>{21187322-52DD-4243-80A4-A85F0263E63B}</Project>
+      <Name>HeuristicLab.Hive.JobBase-3.3</Name>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Hive.Slave.Common\3.3\HeuristicLab.Hive.Slave.Common-3.3.csproj">
@@ -186,17 +192,14 @@
   </ItemGroup>
   <ItemGroup>
-    <WCFMetadataStorage Include="Service References\SlaveService\" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Service References\SlaveService\SlaveService.disco" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Service References\SlaveService\configuration91.svcinfo" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Service References\SlaveService\configuration.svcinfo" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Service References\SlaveService\Reference.svcmap">
+    <WCFMetadataStorage Include="Service References\SlaveFacade\" />
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="Service References\SlaveFacade\configuration91.svcinfo" />
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="Service References\SlaveFacade\configuration.svcinfo" />
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="Service References\SlaveFacade\Reference.svcmap">
       <Generator>WCF Proxy Generator</Generator>
       <LastGenOutput>Reference.cs</LastGenOutput>
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/HeuristicLabHiveSlaveCommunicationPlugin.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/HeuristicLabHiveSlaveCommunicationPlugin.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/HeuristicLabHiveSlaveCommunicationPlugin.cs	(revision 4368)
@@ -36,4 +36,5 @@
   [PluginDependency("HeuristicLab.Hive.Slave.Common", "3.3")]
   [PluginDependency("HeuristicLab.Hive.Contracts", "3.3")]
+  [PluginDependency("HeuristicLab.Hive.JobBase", "3.3")]
   [PluginDependency("HeuristicLab.Tracing", "3.3")]
   public class HeuristicLabHiveSlaveCommunicationPlugin : PluginBase {
